use std::f32::consts;
use std::fs;
use std::io;

use hound;

const SAMPLE_RATE : u32 = 44100;
const TONE        : f32 = 440.0; // 440Hz = A

fn main()
{
    let wav_spec : hound::WavSpec = hound::WavSpec
    {
        channels        : 1,
        sample_rate     : SAMPLE_RATE,
        bits_per_sample : 16,
        sample_format   : hound::SampleFormat::Int
    };

    let mut wav_writer : hound::WavWriter<io::BufWriter<fs::File>> = hound::WavWriter::create("d:/target.wav", wav_spec).unwrap();

    let sample_count : u32 = SAMPLE_RATE * 3; // 3초

    for t in 0..sample_count
    {
        let v : f32 = ((t as f32 / SAMPLE_RATE as f32) * TONE * 2.0 * consts::PI).sin();

        wav_writer.write_sample((v * i16::MAX as f32) as i16).unwrap();
    }
}